import java.awt.*;
import java.applet.*;
import java.awt.image.*;
import java.awt.event.*;

public class DrawImageOffScreenTest extends Applet {

  Graphics imageGraphics;
  Image newImage;
  static DrawingCanvas canvas;
  static int width,height,imageWidth,imageHeight;

  public void init() {
    width=getBounds().width;
    height=getBounds().height;
    this.getComponents();
    canvas = new DrawingCanvas(width,height);
    this.add(canvas);

    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    newImage = getImage(getDocumentBase(),"market.gif");
    screen.drawImage(newImage, 0, 0, this);

    //newImage = Toolkit.getDefaultToolkit().getImage("market.gif");
    imageWidth=newImage.getWidth(this);
    imageHeight=newImage.getHeight(this);
    if (newImage != null) {
      imageGraphics.drawImage(newImage, 0, 0, imageWidth, imageHeight,this);
      canvas.paint(screen);
    }
    else System.out.println("market.gif ikke fundet");
  }
}

class DrawingCanvas extends Component {
  int width,height;

  DrawingCanvas(int width, int height) {
    this.width = width;
    this.height = height;
  }

  private Image offscreenImage;

  public void paint(Graphics screen) {
    if (offscreenImage!=null) screen.drawImage(offscreenImage,0,0,width,height,null);
  }

  public Image getOffscreenImage() {
    if (offscreenImage==null) offscreenImage = createImage(width,height);
    return offscreenImage;
  }

  public Dimension getMinimumSize() {
    return new Dimension(width,height);
  }

  public Dimension getPreferredSize() {
      return new Dimension(width,height);
  }
}
